BUFFER_HEADER equ psize*4

BUFFER_HEADER_FLUSHBUFFER equ psize*1
BUFFER_HEADER_PARAM1 equ psize*2
BUFFER_HEADER_PARAM2 equ psize*3

BUFFER_FUNC_BUFFER_SIZE equ 1024*512 + BUFFER_HEADER ;0,5MB char buffer


;------------------------------------------------------------------------------
;This function will copy a file from base to target. If the size is >50MB or zero it will use ASYNC copy method
;input:
;    1:flushBuffer. function with four paramters: (param1, param2, buffer, size)
;    2:param1
;    3:param2

;output:
;    R/EAX => pointer to buffer
;------------------------------------------------------------------------------
if used createNewBuffer
createNewBuffer:
call denter

push BUFFER_FUNC_BUFFER_SIZE ;10MB buffer
call GetMemLocation
mov pdword [peax],0 ;+0x0 => used size in bytes

mov pecx,pdword [pebp+psize*2] ;flushbuffer
mov pdword [peax+BUFFER_HEADER_FLUSHBUFFER],pecx ;+psize*1 => flushbuffer

mov pecx,pdword [pebp+psize*3] ;param1
mov pdword [peax+BUFFER_HEADER_PARAM1],pecx ;+psize*2 => param1

mov pecx,pdword [pebp+psize*4] ;param2
mov pdword [peax+BUFFER_HEADER_PARAM2],pecx ;+psize*2 => param2

call dleave
ret psize*3
end if

;------------------------------------------------------------------------------
;This function will copy a file from base to target. If the size is >50MB or zero it will use ASYNC copy method
;input:
;    1: pointer to buffer
;------------------------------------------------------------------------------
if used freeBuffer
freeBuffer:
push pdword [pesp+psize*1]
call FlushBuffer

jmp FreeMemLocation
end if


;------------------------------------------------------------------------------
;Pushes all arguments on pointer R/ESI until 0 is found and call CreateOneStringUtf8
;input:
;    1: flags
;    2: pointer to buffer
;    R/ESI: pointer to stack where the first argument is
;------------------------------------------------------------------------------
pushArgumentsAndCallCreateOneStringUtf8:
call denter

xor pecx,pecx
countItemsForCreateOneStringUtf8:
  lodsp

  test peax,peax
  jz lastItemFoundCreateOneStringUtf8

  inc pecx

  lodsp
jmp countItemsForCreateOneStringUtf8

lastItemFoundCreateOneStringUtf8:
sub pesi,psize*2 ;set R/ESI on '0' item
STD

push 0 ;last item
pushItemsForCreateOneStringUtf8:
  lodsp
  push peax
  lodsp
  push peax

loop pushItemsForCreateOneStringUtf8

cld

push pdword [pebp+psize*3] ;pointer to buffer
push pdword [pebp+psize*2] ;flags
call CreateOneStringUtf8

call dleave
ret psize*2



;------------------------------------------------------------------------------
;This function will add something ad to the buffer in UTF-8 format and call flushBuffer if full
;input:
;    1:buffer
;    2:Type:    0x0=last item; 0x1=ANSI string; 0x11=UTF-8 string 0x2=Unicode string;
;               0x3=Decimal number; 0x31=Hexidecimal number;
;               0x4=decimal 64 bit number (pointer in x86, same as 3 in x64);
;               0x41=Hexidecimal number 64 bit number (pointer in x86, same as 31 in x64);
;               0x5=Pointer to long long that needs to formated to "5GB (5.000.000.000 bytes)"
;               0xA=Begin JSON object, 0xB=end JSON object, 0xC then=File attributes
;               0xD=FILETIME that needs to transformed to a string, 0xE=Boolean, 0xF=begin JSON array
;               0x10=end JSON array

;
;               0x10000=Copy caracters upper case; 0x20000=Free pointer; 0x80000 format number as size;
;               0x100000=format number with dots; 0x200000=escape string as JSON string
;               0x400000=is item name in JSON object; 0x800000=is value in JSON object
;               0x1000000=don't add coma in front of JSON object name if 0x400000 is set, else is adds a coma
;         Pointer or integer}
;    3:Item
;    Repeat 2AND3 as much as you like and push a '0' at the end!

;output:
;    R/EAX => pointer to buffer
;------------------------------------------------------------------------------
if used appendBuffer
appendBuffer:
call denter

  lea pesi,pdword [pebp+psize*3] ;first item
  push 0   ;buffer
  push 0x1 ;flags
  call pushArgumentsAndCallCreateOneStringUtf8   ;R/EAX=>size needed for item
  mov pecx,peax  ;R/ECX => size needed

  mov pesi,pdword [pebp+psize*2]  ;R/ESI => buffer
  mov pedx,BUFFER_FUNC_BUFFER_SIZE-(BUFFER_HEADER)
  mov pebx,pdword [pesi] ;R/EBX =>size used by buffer
  sub pedx,pebx          ;R/EdX => free size in buffer
  cmp pedx,peax
  jae addTempStringToBuffer

  _flushBuffer:
    lea peax,pdword [pesi+BUFFER_HEADER]    ;R/EAX => pointer to buffer
    push pebx                               ;size used by buffer
    push peax                               ;buffer
    push pdword [pesi+BUFFER_HEADER_PARAM2] ;param2
    push pdword [pesi+BUFFER_HEADER_PARAM1] ;param1
    call pdword [pesi+BUFFER_HEADER_FLUSHBUFFER] ;flushBuffer function

    xor pebx,pebx                          ;R/EBX => size used by buffer
    mov pdword [pesi],pebx                 ;set used size to 0
    mov pedx,BUFFER_FUNC_BUFFER_SIZE-(BUFFER_HEADER) ;R/EBX => free size in buffer

    cmp pedx,pecx
    jae addTempStringToBuffer

    ;create new buffer with item
    lea pesi,pdword [pebp+psize*3] ;first item
    push 0                     ;end of buffer
    push 0x0                        ;flags
    call pushArgumentsAndCallCreateOneStringUtf8
    mov pedi,peax    ;R/EDI => buffer with item in UTF-8
    mov pesi,pdword [pebp+psize*2]  ;R/ESI => buffer

    push pedi
    call strlen

    push peax                               ;size used by buffer
    push pedi                               ;buffer
    push pdword [pesi+BUFFER_HEADER_PARAM2] ;param2
    push pdword [pesi+BUFFER_HEADER_PARAM1] ;param1
    call pdword [pesi+BUFFER_HEADER_FLUSHBUFFER] ;flushBuffer function

    push pedi
    call FreeMemLocation
    jmp endBuffer

  addTempStringToBuffer:
    ;-add pdword [pesi],pecx ;increment used size of buffer
    lea peax,pdword [pesi+BUFFER_HEADER+pebx]

    ;add item to buffer
    lea pesi,pdword [pebp+psize*3] ;first item
    push peax ;end of buffer
    push 0x0  ;flags
    call pushArgumentsAndCallCreateOneStringUtf8 ;R/EAX => pointer to zero byte, end of the buffer

    mov pesi,pdword [pebp+psize*2]  ;R/ESI => buffer
    ;calculate used size
    sub peax,pesi
    sub peax,BUFFER_HEADER

    mov pdword [pesi],peax ;Set used size

endBuffer:
call dleave

pop peax ;return value

add pesp,psize ;remove buffer

popAllArgumentsFromStack:
  add pesp,psize*2
  cmp pdword [pesp],0
jne popAllArgumentsFromStack

add pesp,psize

jmp peax
end if

;------------------------------------------------------------------------------
;This function will flush the buffer
;input:
;    1:buffer
;output:
;    R/EAX => pointer to buffer
;------------------------------------------------------------------------------
if used FlushBuffer
FlushBuffer:
call denter

  mov pesi,pdword [pebp+psize*2]  ;buffer
  mov pecx,pdword [pesi]          ;R/ECX =>size used by buffer
  jpcxz endFlushBuffer

  lea peax,pdword [pesi+BUFFER_HEADER] ;R/EAX => pointer to buffer

    push pecx                               ;size used by buffer
    push peax                               ;buffer
    push pdword [pesi+BUFFER_HEADER_PARAM2] ;param2
    push pdword [pesi+BUFFER_HEADER_PARAM1] ;param1
    call pdword [pesi+BUFFER_HEADER_FLUSHBUFFER] ;flushBuffer function

  xor pecx,pecx                          ;R/ECX => size used by buffer
  mov pdword [pesi],pecx                 ;set used size to 0

endFlushBuffer:
call dleave
ret psize*1
end if