entry Start

section '.text' code data readable writeable executable

virtual at 0
call NOFileAttributes
NOFileAttributes:
end virtual

include_usefile
include 'windows/fileFunctions.inc'
include 'windows/threadfunctions.inc'
include 'windows/register.inc'
include 'windows/service_windows_nt.inc'
include 'include/math.inc'
;include 'include/stringFunctions.inc'
include 'include/function.inc'

include 'include/general_version_info.inc'

oUrl1 db 'http://127.0.0.1:',0
oUrl2 db '/?action=start&dir1=',0
oUrl3 db '&dir2=',0
oUrl4 db '&',0

open du 'open',0

Caption du 'Which folder do you want to backup?',0
Caption2 du 'Where do you want to save the backup?',0

align 0x10
regKey db "SOFTWARE\TV's software\TV's backup system\ListenSessions\1\TVS_SOFTWARE_TCPIP\listById",0
regValueName db '3',0

errMessage db "Could not find Copy OneOnOne on your system. Please reinstall!",0
errMessageRunning db "Copy OneOnOne service is currently not running. Please go to Windows services configuration and start the service, or, if there are any problems, reinstall the service.",0
errorTitle db 'Error',0

if used is64
  serviceName du "Copy OneOnOne (x64)",0
else
  serviceName du "Copy OneOnOne (x86)",0
end if

Path pointer 0
Path2 pointer 0


Start:
call denter
MakeStack

push BackupSystemNotInstalled
push regValueName
push regKey
mov peax,HKEY_LOCAL_MACHINE
push peax
call ReadRegDwordWithErrorJump
mov ebx,eax ;safe port on EBX

push serviceName
call IsServiceRunning
test eax,eax
jz BackupSystemNotRunning

push Caption
call BrouwseForFolder
test peax,peax
jz Exit

push peax
call escapeString
mov [Path],peax

push 0
push Caption2
call BrouwseForFolderEx
test peax,peax
jz Exit

push peax
call escapeString
mov [Path2],peax


push 0
push oUrl4
push 0x1
push [Path2]
push 0x11
push oUrl3
push 0x1
push [Path]
push 0x11
push oUrl2
push 0x1
push pebx
push 0x3
push oUrl1
push 0x1
call CreateOneString
mov pebx,peax

argpush 6,1
argpush 5,0
argpush 4,0
argpush 3,pebx
argpush 2,open
argpush 1,0
call [ShellExecute]
jmp Exit

BackupSystemNotInstalled:
mov peax,errMessage
jmp showErrMessage

BackupSystemNotRunning:
mov peax,errMessageRunning

showErrMessage:
argpush 4,0x10
argpush 3,errorTitle
argpush 2,peax
argpush 1,0
call [MessageBoxA]


Exit:
push 0
call exitProcess
call dleave
ret

GetMemLocation:
  call denter

  MakeStack

  mov peax,pdword [pebp+(psize*2)]

  argpush 4,0x04;PAGE_READWRITE (0x40 = PAGE_EXECUTE_READWRITE)
  argpush 3,0x1000
  argpush 2,peax
  argpush 1,0
  call [VirtualAlloc]

  call dleave
ret (psize*1)

FreeMemLocation:
  call denter
  MakeStack

  mov pecx,pdword [pebp+(psize*2)]
  jpcxz NothingToFree

  UnsafeFreeMemLocation:
  argpush 3,0x8000
  argpush 2,0
  argpush 1,pecx
  call [VirtualFree]

  NothingToFree:
  call dleave
ret (psize*1)


;----------------------------------------------------
;                      escapeString
;1: string UTF-16
;
;Escapes as the EscapeValue function is documented, the original buffer is first translated to UTF-8, escaped and then freed with FreeMemLocation.
;
;output: (R/E)AX = buffer with escaped string
;
;----------------------------------------------------
escapeString:
call denter

push 0
push pdword [pebp+psize*2] ;inputString
push 0x2 or 0x20000
push 0
push 0
call CreateOneStringUtf8
mov pesi,peax

MakeStack
argpush 3,0
argpush 2,0
argpush 1,pesi ;inputString
call [EscapeValue]

inc peax ;add terminating zero char

push peax
call GetMemLocation
mov pebx,peax

argpush 3,0
argpush 2,pebx ;outputstring
argpush 1,pesi ;inputString
call [EscapeValue]

push pesi
call FreeMemLocation

mov peax,pebx
call dleave
ret psize


;---------------
FileAttributes:
neatSizeFormatA:
FormatNumberA:
FormatBytesA:
getFlagsByNameUtf8:
neatSizeFormat:
FormatNumber:
FormatBytes:
FileTimeToStringBuf:
int3 ;should never be reached


data import
library kernel32,'KERNEL32.DLL',\
        shell32,'SHELL32.DLL',\
        OLE32,'OLE32.DLL',\
        user32,'USER32.DLL',\
        advapi32,'ADVAPI32.DLL',\
        httpProtocol,<'tvs_server_http_protocol_',CPUname,'.dll'>

include 'windows/edited_KERNEL32.INC'
include 'API\SHELL32.INC'
include 'windows\OLE32.INC'
include 'API\USER32.INC'
include 'API\ADVAPI32.INC'
import httpProtocol,\
       EscapeValue,'EscapeValue'

end data

Description_a equ "Graphical userinterface for selecting directories to be backup-ed with Copy OneOnOne."


align 0x10
data resource
  directory RT_VERSION,versions,\
            24,manifest

  resource versions,\
           1,LANG_NEUTRAL,version

  versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,LANG_ENGLISH+SUBLANG_DEFAULT,0,\
              'FileDescription',Description_a,\
              'LegalCopyright', Copyright,\
              'FileVersion',<ProductVersionPrefix, ".", FileVersion> ,\
              'ProductVersion',ProductVersion

  resource manifest,\
           1,LANG_NEUTRAL,mymanifest

  resdata mymanifest
    db '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>'
    db '<assembly xmlns="urn:schemas-microsoft-com:asm.v1" manifestVersion="1.0" xmlns:asmv3="urn:schemas-microsoft-com:asm.v3">'
    db '<assemblyIdentity name="', Developer , '" processorArchitecture="', CPUArchitecture, '" version="' , ProductVersionManifest , '" type="win32"/>'
  ;  db '<description>',Description_a,'</description>'
    db '<compatibility xmlns="urn:schemas-microsoft-com:compatibility.v1">'
    db '  <application>'
    ;db '    <!-- Windows Vista -->'
     db     '<supportedOS Id="{e2011457-1546-43c5-a5fe-008deee3d3f0}"/>'
    ;db '    <!-- Windows 7 -->'
     db     '<supportedOS Id="{35138b9a-5d96-4fbd-8e2d-a2440225f93a}"/>'
    ;db '    <!-- Windows 8 -->'
     db     '<supportedOS Id="{4a2f28e3-53b9-4441-ba9c-d69d4a4a6e38}"/>'
    ;db '    <!-- Windows 8.1 -->'
     db     '<supportedOS Id="{1f676c76-80e1-4239-95bb-83d0f6d0da78}"/>'
    ;db '    <!-- Windows 10 -->'
    db     '<supportedOS Id="{8e0f7a12-bfb3-4fe8-b9a5-48fd50a15a9a}"/>'
    db   '</application>'
    db '</compatibility>'
    db '</assembly>'
  endres
end data